package com.winhc.task;

import com.alibaba.fastjson.JSONObject;
import com.aliyun.oss.OSS;
import com.aliyun.oss.OSSClientBuilder;
import com.winhc.task.bean.Company;
import com.winhc.task.bean.CompanyOut;
import com.winhc.task.common.CompanyChangeArgs;
import com.winhc.task.util.CsvToXlsxUtil;
import com.winhc.task.util.ZipUtils;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.stream.Collectors;

import static com.winhc.task.common.Constant.*;
import static com.winhc.task.util.CsvToXlsxUtil.jsonToXLSxNewCompany;
import static com.winhc.task.util.CsvToXlsxUtil.jsonToXLSxChange;
import static com.winhc.task.util.DateUtils.getYesterday_ymd;

/**
 * @author π
 * @Description:
 * @date 2022/11/7 16:10
 */
public class TransToExcelNewCompany {


    public static void main(String[] args) throws IOException {
        String ds = getYesterday_ymd();
        //ds = "20221114";
        String outPathPre = "D:\\tmp\\data\\" + ds + "\\";
        File file = new File(outPathPre);
        //如果文件夹不存在则会创建
        if (!file.exists()) file.mkdirs();
        //单个变更维度
        //toTrans(ds,"company_equity_info");
        //新公司
        newCompanyToExcel(outPathPre, ds);
        //变更
        changeToExcel(outPathPre, ds);
        //压缩文件
        FileOutputStream outZipPath = new FileOutputStream(new File("D:\\tmp\\data\\" + ds + ".zip"));
        ZipUtils.toZip("D:\\tmp\\data\\" + ds, outZipPath, true);

    }

    public static void changeToExcel(String outPathPre, String ds) {
        Map<String, CompanyChangeArgs> exportArgs = CompanyChangeArgs.EXPORT_ARGS;
        exportArgs.keySet().forEach(tn -> {
            toTrans(outPathPre, ds, tn);
        });

    }

    private static void toTrans(String outPathPre, String ds, String tn) {
        Map<String, CompanyChangeArgs> exportArgs = CompanyChangeArgs.EXPORT_ARGS;
        CompanyChangeArgs args = exportArgs.get(tn);
        Function<JSONObject, JSONObject> handles = args.getHandles();
        List<List<String>> company_head_list = Arrays.stream(args.getHead().split("@"))
                .map(Collections::singletonList)
                .collect(Collectors.toList());
        String objectName = "anshuo/dim_change/" + ds + "/" + tn + ".json";
        //String outPath = "D:\\tmp\\data\\change_" + tn + ".xlsx";
        String outPath = outPathPre + "change_" + tn + ".xlsx";
        jsonToXLSxChange(tn, outPath, objectName, company_head_list, args.getClazz(), handles);
    }

    public static void newCompanyToExcel(String outPathPre, String ds) {

        List<List<String>> company_head_list = Arrays.stream(company_head.split("@"))
                .map(Collections::singletonList)
                .collect(Collectors.toList());

        List<List<String>> holder_head_list = Arrays.stream(holder_head.split("@"))
                .map(Collections::singletonList)
                .collect(Collectors.toList());

        List<List<String>> staff_head_list = Arrays.stream(staff_head.split("@"))
                .map(Collections::singletonList)
                .collect(Collectors.toList());

        String objectName = "anshuo/new_company/" + ds + "/new_company.json";

        jsonToXLSxNewCompany(outPathPre, objectName, company_head_list, holder_head_list, staff_head_list);
    }
}


